"""
This module contains constants which are used through out the package.
"""
import pandas as pd

DV_DEPRECATE = 'Explicit instance of this class is deprecated in future versions of OLMONK. ' \
               'Instead start using ConfigDataValidator to create this instance'
DEPRECATE_ALWAYS = 'always'
DEPRECATE_CDV_PATH = 'olmonk/config_data_validation.py'
DEPRECATE_INIT = '__init__'
DEPRECATE_IGNORE = 'ignore'
MSG_PATH_DOESNT_EXIST = "File path does not exist"
MSG_EMPTY_FILE = "File is empty"
MSG_WRONG_FORMAT = "File format not supported"
MSG_REQUIRED_COLUMNS_ABSENT_PART1 = "Missing or Misspelled column(s): "
MSG_REQUIRED_COLUMNS_ABSENT_PART2 = " Kindly check and retry."
SHOULD_BE_DICT = 'Argument should be a Dictionary'
DICT_FILE_PATH = 'file_path'
DICT_REQUIRED_COLUMN = 'required_columns'
DICT_WARNINGS = 'warnings'
SAME_STATE_ERROR = "Two entries for same state : "
DICT_FUNCTIONS = 'functions'
DICT_SPECIFIC_CHECKS = 'specific_checks'
DICT_STATE = 'state'
DICT_NEGATIVE_STATE = 'negative state'
DICT_INVALID_STATE = 'invalid state'
LIST_COLUMNS = 'list_of_columns'
COLUMN_LIST = 'column_list'
DICT_NUMERICAL_MIN = 'min'
MISSING_DATA = 'missing_data'
DUPLICATE = 'duplicate'
NUMERICAL = 'numerical'
CHEMICAL_FORMULA = 'chemical_formula'
VALUE_IN_CONSTANT = 'value_in_constant'
PATTERN_MATCH = 'pattern_match'
CHECK_COLUMN_EXISTS = 'check_column_exists'
CHECK_DUPLICATE_COLUMN = 'check_duplicate_column'
CHECK_IF_SUBSET = 'check_if_subset'
CHECK_IF_INTERSECT = 'check_if_intersect'
FAILED = 'This check Failed.'
CHECK_SET = 'check_set'
CONSTANT_LIST = 'constant_list'
REGEX_PATTERN = 'regex_pattern'
FUNCTION_LIST = 'function_list'

COLUMN_STATE = 'state'
COLUMN_ROW = 'row_number'
COLUMN_NAME = 'column_name'
MISSING_STATE = 'missing'
DUPLICATE_STATE = 'duplicate'
DUPLICATE_COLUMN_STATE = 'duplicate column'
INTENSITY_STATE_NEGATIVE = 'negative intensity value'
VALID_STATE = 'OK'
INTENSITY_STATE_INVALID = 'invalid value'
FORMULA_INVALID_STATE = 'invalid formula'
VALUE_IN_CONSTANT_INVALID_STATE = 'value not found'
PATTERN_INVALID_STATE = 'incorrect format'
VALIDATION_WARNING = 'warnings'
VALIDATION_ERROR = 'errors'
VALIDATION_ACTION_DROP = 'DROP'
VALIDATION_ACTION_FILL_NA = 'FILL_NA'
VALIDATION_ACTION_ZERO = 'FILL_ZERO'
VALIDATION_ACTION_STOP = 'Stop_Tool'
WARNING_STATE = {MISSING_STATE: VALIDATION_ACTION_DROP, DUPLICATE_STATE: VALIDATION_ACTION_FILL_NA,
                 DICT_NEGATIVE_STATE: VALIDATION_ACTION_ZERO}
VALIDATION_MESSAGE = 'message'
VALIDATION_ACTION = 'action'
# TODO: need to remove VALIDATION_COLUMN_NAME (duplicate to COLUMN_NAME)
VALIDATION_COLUMN_NAME = 'column_name'
VALIDATION_ACTION_OK = 'All_Ok'
VALIDATION_ACTION_ROW_WISE = 'Row Wise Action'
VALIDATION_MSG_ROW_DROPPED = "Row is Dropped"
VALIDATION_MSG_FILL_NA = "Missing value of columns replaced with 0"
KNOWN_EXTENSION = {'.xls': pd.read_excel,
                   '.xlsx': pd.read_excel,
                   '.csv': pd.read_csv,
                   '.txt': pd.read_table}
EMPTY_CONFIG_DICT = {
    'file_path': '',
    'required_columns': [],
    'function': {},
    'actions':  {}
}

